2025年--Lc186--64. 最小路径和(多维动态规划,矩阵)--Java版

1.题目


2.思路

(1)dpij的定义:从起点(0,0)到位置(i,j)的最小路径和

(2)dpij的递推公式:对于位置(i,j)只能从(i-1,j)或(i,j-1)走过来。所以dpi,j=gridij+Math.min(dpi-1j,dpij-1).

gridij是消耗当前格子的值,Math.min(dpi-1j,dpij-1)是从上走或从左走的路径最小值。

(3)初始化:

起点到起点的路径和(即当前格子)dp00=grid00

第一行(从左走来)

dp0j=dp0j-1+grid0j

第一列(从上走来)

dpi0=dpi-10+gridi0

(4)遍历顺序:从上到下,从左到右

3.代码实现

java 复制代码
class Solution {
    public int minPathSum(int[][] grid) {
        //行数
        int m=grid.length;
        //列数
        int n=grid[0].length;
        //边界情况,只有一行或者只有一列,这样就无法从左上角走到右下角,所以最小路径和为0
        if(m==0||n==0)
        {return 0;}
         //定义dp数组
        int[][] dp=new int[m][n];
        dp[0][0]=grid[0][0];
        //初始化第一列
        for(int i=1;i<m;i++)
        {//因为是求最小路径和,当前元素的值,等于他左边元素加上当前元素的值
            dp[i][0]=dp[i-1][0]+grid[i][0];
        }
        //初始化第一行
        for(int j=1;j<n;j++)
        {
            dp[0][j]=dp[0][j-1]+grid[0][j];
        }
        //第一行和第一列已经初始化过了,所以我们从第二行第二列开始。
        for(int i=1;i<m;i++)
        {
            for(int j=1;j<n;j++)
            {
                dp[i][j]=grid[i][j]+Math.min(dp[i-1][j],dp[i][j-1]);
            }
        }
        return dp[m-1][n-1];
    }
}```
相关推荐
天河归来7 小时前
第三方接口不稳定,如何让核心任务继续完成
java·大数据
Knight_AL7 小时前
Java 文件下载时文件名中的 `#` 被转换成 `%23`?一次 URL 编码与解码问题排查
java·开发语言
砚底藏山河9 小时前
python量化自定义周期 K 线合成
java·开发语言·数据库·python·金融
猿究院_夏燊9 小时前
MySQL 的四种隔离级别
java·数据库·mysql
码流子10 小时前
移动收费怎么做?手持终端+App+收费中心的架构实践
java·开发语言·架构
霸道流氓气质10 小时前
AI 流式对话与实时聊天平台:SSE 解码竞态、有状态会话隔离与背压取消的 Vue3 + Spring AI 生产级实战
java·人工智能·spring
云创智城-yuncitys10 小时前
YunParking 4.0:JDK 17 与 Spring Boot 3.2 的停车云升级
java·开发语言·spring boot
文丑颜不良啊10 小时前
LeetCode1661~1680题目解析
java·leetcode
子非鱼@Itfuture10 小时前
关于前后端联调中登录状态/登录信息失效?
java·前端
郭小李10 小时前
openFeign入门
java·开发语言·前端